package org.processmining.acceptingpetrinet.connections;

import org.processmining.acceptingpetrinet.models.AcceptingPetriNet;
import org.processmining.acceptingpetrinet.parameters.UnpackPetrinetParameters;
import org.processmining.framework.connections.impl.AbstractConnection;
import org.processmining.models.graphbased.directed.petrinet.Petrinet;

public class UnpackPetrinetConnection extends AbstractConnection {

	public final static String APN = "APN";
	public final static String NET = "NET";

	private UnpackPetrinetParameters parameters;

	public UnpackPetrinetConnection(AcceptingPetriNet apn, Petrinet net,
			UnpackPetrinetParameters parameters) {
		super("Unpack Petri net Connection");
		put(APN, apn);
		put(NET, net);
		this.parameters = new UnpackPetrinetParameters(parameters);
	}

	public UnpackPetrinetParameters getParameters() {
		return parameters;
	}
}
