package org.processmining.acceptingpetrinet.filters.impl;

import java.util.HashSet;
import java.util.Set;

import org.processmining.acceptingpetrinet.filters.StartEndFilterParameters;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.models.graphbased.directed.petrinet.Petrinet;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;
import org.processmining.models.semantics.petrinet.Marking;

public class StartEndHideFilter extends StartEndAbstractFilter {

	public final static String NAME = "Hide Start/End";
	
	public void apply(PluginContext context, Petrinet pn, Marking initialMarking, Set<Marking> finalMarkings, 
			StartEndFilterParameters parameters) {
		Set<Transition> transitions = new HashSet<Transition>(pn.getTransitions());
		for (Transition transition : transitions) {
			if (transition.getLabel().equals(parameters.getStartLabel())) {
				transition.setInvisible(true);
			} else if (transition.getLabel().equals(parameters.getEndLabel())) {
				transition.setInvisible(true);
			}
		}
	}

	public String getName() {
		return NAME;
	}

}
