/**
 * 
 */
package org.processmining.models.visualcnet.util;

import java.util.Iterator;
import java.util.Set;

import org.processmining.models.cnet.CNetBinding;
import org.processmining.models.cnet.CNetNode;

/**
 * @author Arya Adriansyah
 * @email a.adriansyah@tue.nl
 * @version
 * 
 */
public class TextTransformer {
	public static String getBindingLabels(Set<CNetBinding> setBindings) {
		int counter = 0;
		int size = 0;

		StringBuffer strBuf = new StringBuffer();
		for (CNetBinding binding : setBindings) {
			counter = 0;
			size = binding.getBoundNodes().size();
			strBuf.append("{");
			for (CNetNode node : binding.getBoundNodes()) {
				counter++;
				strBuf.append(node.getLabel());
				if (counter < size) {
					strBuf.append(",");
				}
			}
			strBuf.append("}");
		}

		return strBuf.toString();
	}

	public static String getBindingLabelHTMLTable(Set<CNetBinding> setBindings) {
		int counter = 0;
		int size = 0;

		StringBuffer strBuf = new StringBuffer();
		for (Iterator<CNetBinding>it = setBindings.iterator(); it.hasNext();) {
			CNetBinding binding = it.next();
			counter = 0;
			size = binding.getBoundNodes().size();
			strBuf.append("{");
			for (CNetNode node : binding.getBoundNodes()) {
				counter++;
				strBuf.append(node.getLabel());
				if (counter < size) {
					strBuf.append(",");
				}
			}
			strBuf.append("}</td></tr>");
			if (it.hasNext()) {
				strBuf.append("<tr><td></td><td>");
			}
		}

		return strBuf.toString();
	}
}
