package org.processmining.plugins.properties.processmodel.abstractproperty;

import java.util.ArrayList;
import java.util.List;

import org.processmining.plugins.properties.processmodel.gui.GUIProperty;
import org.processmining.plugins.properties.processmodel.gui.impl.GUIPropertyListDouble;

/**
 * 
 * @author DSchunse
 *
 */
@SuppressWarnings("serial")
public abstract class PropertyListDouble extends PropertyList<Double>{
	public Object unmarshall(String xml){
		return unmarshallStatic(xml);
	}
	
	public static Object unmarshallStatic(String xml){
		List<Double> ret = new ArrayList<Double>();
		// we have a string with valueEntries
		String[] values = xml.split("<valueEntry value=\"");
		for(String s: values){
			if(!s.isEmpty()){
				ret.add(Double.valueOf(s.split("\"")[0]));
			}
		}
		return ret;
	}
	
	public GUIProperty<List<Double>> getGUIProperty() throws InstantiationException, IllegalAccessException {
		return GUIPropertyListDouble.class.newInstance();
	}
	
	@SuppressWarnings("unchecked")
	public List<Double> clone(Object element){
		List<Double> elem = (List<Double>) element;
		List<Double> ret = new ArrayList<Double>();
		for(Double d: elem){
			ret.add(new Double(d));
		}
		return ret;
	}
}
