package org.processmining.plugins.properties.processmodel.abstractproperty;

import java.util.HashMap;
import java.util.Map;

/**
 * 
 * @author DSchunse
 *
 */
@SuppressWarnings("serial")
public abstract class PropertyMapIntegerDouble extends HighLevelProperty<Map<Integer, Double>>{
	
	@SuppressWarnings("unchecked")
	public String marshall(Object values){
		Map<Integer, Double> value = (Map<Integer, Double>) values;
		String ret = "";
		for(Integer key: value.keySet()){
			ret += "<valueEntry key=\"" + key + "\" value=\"" + value.get(key) + "\" />\n"; 
		}
		return ret;
	}
	
	public Object unmarshall(String xml){
		Map<Integer, Double> values = new HashMap<Integer, Double>();
		// we have a set of <value things
		String[] valueString = xml.split("<valueEntry");
		for(String s: valueString){
			if(!s.isEmpty()){
				int key = Integer.valueOf(s.substring(s.indexOf("\"") + 1, s.indexOf("\"", s.indexOf("\"") + 1)));
				String valueStr = s.split("value")[1];
				double value = Double.valueOf(valueStr.substring(valueStr.indexOf("\"") + 1, valueStr.indexOf("\"", valueStr.indexOf("\"") + 1)));
				values.put(key, value);
			}
		}
		return values;
	}
	
	@SuppressWarnings("unchecked")
	public Map<Integer, Double> clone(Object element){
		Map<Integer, Double> elem = (Map<Integer, Double>) element;
		Map<Integer, Double> ret = new HashMap<Integer, Double>();
		for(Integer i: elem.keySet()){
			ret.put(new Integer(i), new Double(elem.get(i)));
		}
		return ret;
	}
	
}
