package org.processmining.plugins.properties.processmodel.configurable;

import java.util.Map;

import org.processmining.framework.util.Pair;
import org.processmining.plugins.properties.processmodel.Property;

/**
 * 
 * @author DSchunse
 *
 * @param <K>
 */
public interface ConfigurableProperty<K> extends Property<Pair<K, K>>{
	public Class<? extends Property<?>> getNonConfigurableVariant();
	
	public ConfigurablePropertyIterator<K> getIterator(Object values);
	
	public Object instantiate(Object elements, Object config);
	
	public Object instantiate(Object elements, ConfigurablePropertyConfiguration<K> config);
	
	public Object instantiateTotal(Object elements, Object config);
	
	public Object instantiateTotal(Object elements, ConfigurablePropertyConfiguration<K> config);
	
	public boolean isValidConfiguration(Object elements, ConfigurablePropertyConfiguration<K> config, Map<Class<? extends ConfigurableProperty<?>>, ?> dependentProperties);
	
	public boolean isTotalConfiguration(Object elements, ConfigurablePropertyConfiguration<K> config);
	
	/**
	 * All elements not selected to be removed are added to the nonRemoved part
	 * @param elements
	 * @param config
	 */
	public void makeTotalConfiguration(Object elements, ConfigurablePropertyConfiguration<K> config);
	
	public Object makeNonConfigurable(Object elements);
	
	public Object makeConfigurable(Object element);

}
