package org.processmining.plugins.properties.processmodel.gui.abstractguiproperty;

import info.clearthought.layout.TableLayout;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import javax.swing.AbstractAction;

import org.processmining.plugins.properties.processmodel.PropertableElement;
import org.processmining.plugins.properties.processmodel.Property;
import org.processmining.plugins.properties.processmodel.gui.GUIProperty;

import com.fluxicon.slickerbox.components.SlickerTabbedPane;

/**
 * 
 * @author DSchunse
 *
 */
public class DeleteButton extends AbstractAction{

	private static final long serialVersionUID = 1L;
	
	private PropertableElement element;
	private GUIProperty<?> guiProperty;
	private Property<?> property;
	private Boolean independent;
	protected SlickerTabbedPane tabpane;
	protected List<List<List<Object>>> lines;
	protected List<List<Object>> myLine;
	protected HashMap<DeleteButton, List<Integer>> indices;
	protected List<Component> components;
	
	public DeleteButton(SlickerTabbedPane tabpane, List<List<List<Object>>> lines, List<List<Object>> myLine,
			HashMap<DeleteButton, List<Integer>> indices, List<Component> components, int header) {
		this(null, null, null, null, tabpane, lines, myLine, indices, components, header);
	}
	
	public DeleteButton(PropertableElement element, GUIProperty<?> guiProperty, Property<?> property, Boolean independent, SlickerTabbedPane tabpane, List<List<List<Object>>> lines, List<List<Object>> myLine,
			HashMap<DeleteButton, List<Integer>> indices, List<Component> components, int header) {
		super();
		this.element = element;
		this.guiProperty = guiProperty;
		this.property = property;
		this.independent = independent;
		this.tabpane = tabpane;
		this.lines = lines;
		this.myLine = myLine;
		this.indices = indices;
		this.components = components;
		// now add the index of this component
		int index = header;
		for(DeleteButton delb: indices.keySet()){
			for(Integer i: indices.get(delb)){
				index = Math.max(i, index);
			}
		}
		// now put the list of integers for this component
		ArrayList<Integer> ints = new ArrayList<Integer>();
		for(int i = 0; i < myLine.size(); i++){
			ints.add(index + 1 + i);
		}
		indices.put(this, ints);
	}
	
	public void actionPerformed(ActionEvent e) {
		// Assumption we are removing consecutive rows
		int minimalInt = Integer.MAX_VALUE;
		int offset = 0;
		for(Integer i: indices.get(this)){
			((TableLayout)tabpane.getLayout()).deleteRow(i - offset);
			minimalInt = Math.min(minimalInt, i - offset);
			offset++;
		}
		for(Component comp: components){
			tabpane.remove(comp);
		}
		// now update the indices
		for(DeleteButton delb: indices.keySet()){
			for(int i = 0; i < indices.get(delb).size(); i++){
				if(indices.get(delb).get(i) > minimalInt){
					indices.get(delb).set(i, indices.get(delb).get(i) - indices.get(this).size());
				}
			}
		}
		lines.remove(myLine);
		indices.remove(this);
		tabpane.revalidate();
		tabpane.getParent().invalidate();
		tabpane.getParent().repaint();
		tabpane.getParent().getParent().invalidate();
		tabpane.getParent().getParent().repaint();
		if(element != null){
			if(independent){
				try {
					element.setIndependentProperty(property, guiProperty.parseComponents(property, lines));
				} catch (InstantiationException | IllegalAccessException ex) {
					// TODO Auto-generated catch block
					ex.printStackTrace();
				}
			}
			else{
				try {
					element.setDependentProperty(property, guiProperty.parseComponents(property, lines));
				} catch (InstantiationException | IllegalAccessException ex) {
					// TODO Auto-generated catch block
					ex.printStackTrace();
				}
			}
		}
	}

}
