package org.processmining.plugins.properties.processmodel.gui.abstractguiproperty;

import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.ArrayList;
import java.util.List;

import javax.swing.JComponent;

import org.processmining.plugins.properties.processmodel.PropertableElement;
import org.processmining.plugins.properties.processmodel.Property;
import org.processmining.plugins.properties.processmodel.gui.GUIProperty;
import org.processmining.plugins.properties.processmodel.gui.impl.GUIHelperFunction;

/**
 * 
 * @author DSchunse
 *
 */
public class SinglePageElementMouseListener implements MouseListener{
	PropertableElement element;
	GUIProperty<?> guiProperty;
	Property<?> property;
	Boolean independent;
	List<List<JComponent>> componentsDataRow;
	
	
	public SinglePageElementMouseListener(PropertableElement element, GUIProperty<?> guiProperty, Property<?> property, Boolean independent, List<List<JComponent>> componentsDataRow){
		this.element = element;
		this.guiProperty = guiProperty;
		this.property = property;
		this.independent = independent;
		this.componentsDataRow = componentsDataRow;
	}
	
	private void doSomething(){
		List<List<List<Object>>> lines = new ArrayList<List<List<Object>>>();
		List<List<Object>> lineGroup = new ArrayList<List<Object>>();
		for(List<JComponent> components: componentsDataRow){
			List<Object> line = new ArrayList<Object>();
			for(JComponent comp: components){
				line.add(GUIHelperFunction.getValue(comp));
			}
			lineGroup.add(line);
		}
		lines.add(lineGroup);
		if(independent){
			try {
				element.setIndependentProperty(property, guiProperty.parseComponents(property, lines));
			} catch (InstantiationException | IllegalAccessException ex) {
				// TODO Auto-generated catch block
				ex.printStackTrace();
			}
		}
		else{
			try {
				element.setDependentProperty(property, guiProperty.parseComponents(property, lines));
			} catch (InstantiationException | IllegalAccessException ex) {
				// TODO Auto-generated catch block
				ex.printStackTrace();
			}
		}
	}
	
	public void mouseClicked(MouseEvent arg0) {
		doSomething();
	}

	public void mouseEntered(MouseEvent arg0) {
		doSomething();
	}

	public void mouseExited(MouseEvent arg0) {
		doSomething();		
	}

	public void mousePressed(MouseEvent arg0) {
		doSomething();
	}

	public void mouseReleased(MouseEvent arg0) {
		doSomething();
	}

}
