package org.processmining.plugins.properties.processmodel.gui.impl;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JTextField;

import org.processmining.framework.util.Pair;
import org.processmining.plugins.properties.processmodel.PropertableElement;
import org.processmining.plugins.properties.processmodel.Property;
import org.processmining.plugins.properties.processmodel.gui.abstractguiproperty.AddButton;
import org.processmining.plugins.properties.processmodel.gui.abstractguiproperty.GUIPropertyListOfElements;
import org.processmining.plugins.properties.processmodel.impl.DataValues;

import com.fluxicon.slickerbox.factory.SlickerFactory;

/**
 * 
 * @author DSchunse
 *
 */
public class GUIPropertyDataValueMatrix extends GUIPropertyListOfElements<HashMap<Pair<String, String>, Double>> {

	public <E extends PropertableElement> List<List<JComponent>> getHeaderRows(E element){
		ArrayList<List<JComponent>> header = new ArrayList<List<JComponent>>();
		JLabel lfrom = SlickerFactory.instance().createLabel("From");
		JLabel lto = SlickerFactory.instance().createLabel("To");
		JLabel lprob = SlickerFactory.instance().createLabel("Probability");
		ArrayList<JComponent> head = new ArrayList<JComponent>();
		head.add(lfrom);
		head.add(lto);
		head.add(lprob);
		header.add(head);
		return header;
	}

	@SuppressWarnings("unchecked")
	public <E extends PropertableElement> List<List<JComponent>> getDataRow(E element) throws InstantiationException, IllegalAccessException{
		ArrayList<List<JComponent>> dataRows = new ArrayList<List<JComponent>>();
		ArrayList<JComponent> data = new ArrayList<JComponent>();
		if(element.getIndependentProperty(DataValues.class) != null){
			if(!((ArrayList<String>)element.getIndependentProperty(DataValues.class)).isEmpty()){
				data.add(SlickerFactory.instance().createComboBox(((ArrayList<String>)element.getIndependentProperty(DataValues.class)).toArray()));
				data.add(SlickerFactory.instance().createComboBox(((ArrayList<String>)element.getIndependentProperty(DataValues.class)).toArray()));
			}
			else{
				data.add(SlickerFactory.instance().createLabel("No Value"));
				data.add(SlickerFactory.instance().createLabel("No Value"));
			}
		}
		else{
			data.add(SlickerFactory.instance().createLabel("No Value"));
			data.add(SlickerFactory.instance().createLabel("No Value"));
		}
		data.add(new JTextField(60));
		dataRows.add(data);
		return dataRows;
	}

	public <P extends Property<?>> HashMap<Pair<String, String>, Double> parseComponents(P property, List<List<List<Object>>> lines) throws InstantiationException, IllegalAccessException{
		HashMap<Pair<String, String>, Double> ret = new HashMap<Pair<String,String>, Double>();
		// the first one is empty
		for(List<List<Object>> valueList: lines){
			for(List<Object> value: valueList){
				// we have 3 values so lets get them
				String from = (String) value.get(0);
				String to = (String) value.get(1);
				Double prob = Double.valueOf((String)value.get(2));
				ret.put(new Pair<String, String>(from, to), prob);
			}
		}
		return ret;
	}

	@SuppressWarnings("unchecked")
	public <E extends PropertableElement, P extends Property<?>> void fillGUI(P prop, E element, AddButton button, List<List<JComponent>> dataRows, boolean independent) throws InstantiationException, IllegalAccessException{
		HashMap<Pair<String, String>, Double> values = (HashMap<Pair<String, String>, Double>)element.getIndependentProperty(prop);
		// get the possible values for this
		List<String> possVals = (List<String>)element.getIndependentProperty(DataValues.class);
		if(values != null){
			for(Pair<String, String> fromTo: values.keySet()){
				// we have a single list of elements
				if(possVals.contains(fromTo.getFirst()) && possVals.contains(fromTo.getSecond())){
					((JComboBox)dataRows.get(0).get(0)).setSelectedItem(fromTo.getFirst());
					((JComboBox)dataRows.get(0).get(1)).setSelectedItem(fromTo.getSecond());
					((JTextField)dataRows.get(0).get(2)).setText(values.get(fromTo).toString());
					button.actionPerformed(null);
				}
			}
		}
	}

}
