package org.processmining.plugins.properties.processmodel.gui.impl;

import java.util.ArrayList;
import java.util.List;

import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JTextField;

import org.processmining.plugins.properties.processmodel.PropertableElement;
import org.processmining.plugins.properties.processmodel.Property;
import org.processmining.plugins.properties.processmodel.gui.abstractguiproperty.AddButton;
import org.processmining.plugins.properties.processmodel.gui.abstractguiproperty.GUIPropertyListOfElements;

import com.fluxicon.slickerbox.factory.SlickerFactory;

/**
 * 
 * @author DSchunse
 *
 * @param <K>
 */
public abstract class GUIPropertyList<K> extends GUIPropertyListOfElements<List<K>>{
	@SuppressWarnings("unchecked")
	public <E extends PropertableElement, P extends Property<?>> void fillGUI(P prop, E element, AddButton button, List<List<JComponent>> dataRows, boolean independent) throws InstantiationException, IllegalAccessException{
		// now just set all of the fields and call the button
		List<K> values = (List<K>)element.getIndependentProperty(prop);
		if(values != null){
			for(K s: values){
				// we know the datarows is size 1, and size 1
				((JTextField)dataRows.get(0).get(0)).setText(s.toString());
				button.actionPerformed(null);
			}
		}
	}
	
	public <E extends PropertableElement> List<List<JComponent>> getHeaderRows(E element) {
		ArrayList<List<JComponent>> header = new ArrayList<List<JComponent>>();
		JLabel ldata = SlickerFactory.instance().createLabel("Element name: ");
		JLabel lname = SlickerFactory.instance().createLabel(element.getName());
		JLabel lvalue = SlickerFactory.instance().createLabel("Value");
		ArrayList<JComponent> head = new ArrayList<JComponent>();
		head.add(ldata);
		head.add(lname);
		header.add(head);
		head = new ArrayList<JComponent>();
		head.add(lvalue);
		header.add(head);
		return header;
	}

	public <E extends PropertableElement> List<List<JComponent>> getDataRow(E element) throws InstantiationException, IllegalAccessException {
		ArrayList<List<JComponent>> dataRows = new ArrayList<List<JComponent>>();
		ArrayList<JComponent> data = new ArrayList<JComponent>();
		data.add(new JTextField(60));
		dataRows.add(data);
		return dataRows;
	}
}
