package org.processmining.plugins.properties.processmodel.gui.impl;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.swing.JComponent;
import javax.swing.JTextField;

import org.processmining.plugins.properties.processmodel.PropertableElement;
import org.processmining.plugins.properties.processmodel.Property;
import org.processmining.plugins.properties.processmodel.gui.abstractguiproperty.AddButton;
import org.processmining.plugins.properties.processmodel.gui.abstractguiproperty.GUIPropertyListOfElements;

/**
 * 
 * @author DSchunse
 *
 */
public abstract class GUIPropertyMapIntegerDouble extends GUIPropertyListOfElements<Map<Integer, Double>> {

	@SuppressWarnings("unchecked")
	public <E extends PropertableElement, P extends Property<?>> void fillGUI(P prop, E element, AddButton button, List<List<JComponent>> dataRows, boolean independent) throws InstantiationException, IllegalAccessException{
		// now just set all of the fields and call the button
		Map<Integer, Double> values = null;
		if(independent){
			if(element.getIndependentProperty(prop) != null){
				values = (Map<Integer, Double>) element.getIndependentProperty(prop);
			}
		}
		else{
			if(element.getDependentProperty(prop) != null){
				values = (Map<Integer, Double>) element.getDependentProperty(prop);
			}
		}
		if(values != null){
			for(Integer d: values.keySet()){
				// we know the datarows is size 1, and size 1
				((JTextField)dataRows.get(0).get(0)).setText(d.toString());
				((JTextField)dataRows.get(0).get(1)).setText(values.get(d).toString());
				button.actionPerformed(null);
			}
		}
	}
	
	public <E extends PropertableElement> List<List<JComponent>> getDataRow(E element) throws InstantiationException, IllegalAccessException{
		List<List<JComponent>> dataRows = new ArrayList<List<JComponent>>();
		List<JComponent> data = new ArrayList<JComponent>();
		data.add(new JTextField(60));
		data.add(new JTextField(60));
		dataRows.add(data);
		return dataRows;
	}
	
	@SuppressWarnings("unchecked")
	public <P extends Property<?>> Map<Integer, Double> parseComponents(P property, List<List<List<Object>>> lines) throws InstantiationException, IllegalAccessException{
		Map<Integer, Double> dataValues = new HashMap<Integer, Double>();
		for(List<List<Object>> value: lines){
			// we only have 1
			for(List<Object> component: value){
				Integer key = Integer.valueOf((String) component.toArray()[0]);
				Double val = Double.valueOf((String) component.toArray()[1]);
				if(key != null && val != null){
					dataValues.put(key, val);
				}
			}
		}
		if(dataValues.size() == 0){
			// we have a special case
			dataValues = (Map<Integer, Double>) property.getDefaultValue();
		}
		return dataValues;
	}
}
