package org.processmining.plugins.properties.processmodel.impl;

import java.util.HashSet;
import java.util.Set;

import org.processmining.framework.plugin.annotations.KeepInProMCache;
import org.processmining.plugins.properties.annotations.EnvironmentPerspective;
import org.processmining.plugins.properties.annotations.PropertableElementProperty;
import org.processmining.plugins.properties.enumerations.Constructs;
import org.processmining.plugins.properties.enumerations.DistributionType;
import org.processmining.plugins.properties.enumerations.TimeOptions;

/**
 * 
 * @author DSchunse
 *
 */
@KeepInProMCache
@EnvironmentPerspective
@PropertableElementProperty
public class ArrivalProcess extends Distribution {

	private static final long serialVersionUID = -5090854327664326825L;

	public ArrivalProcess(){
		
	}
	
	public ArrivalProcess(Distribution distr){
		super(distr);
	}

	public Long getID() {
		return serialVersionUID;
	}
	
	public ArrivalProcess clone(Object element){
		return new ArrivalProcess((Distribution) element);
	}
	
	public ArrivalProcess getDefaultValue() {
		ArrivalProcess ret = new ArrivalProcess();
		ret.distributionType = DistributionType.Constant;
		ret.timeGranularity = TimeOptions.millisecond;
		ret.mean = 0d;
		return ret;
	}
	
	public String getName() {
		return "ArrivalProcess";
	}

	public Set<Constructs> getMeaningfulTypeConstructs() {
		Set<Constructs> constructs =  new HashSet<Constructs>();
		constructs.add(Constructs.Model);
		return constructs;
	}
	
	public Object unmarshall(String xml){
		return new ArrivalProcess((Distribution)super.unmarshall(xml));
	}
}
