package org.processmining.plugins.properties.processmodel.impl;

import java.util.HashSet;
import java.util.Set;

import org.processmining.framework.plugin.annotations.KeepInProMCache;
import org.processmining.plugins.properties.annotations.PropertableElementProperty;
import org.processmining.plugins.properties.enumerations.Constructs;
import org.processmining.plugins.properties.processmodel.abstractproperty.PropertyDouble;

/**
 * 
 * @author DSchunse
 *
 */
@KeepInProMCache
@PropertableElementProperty
public class Costs extends PropertyDouble {

	private static final long serialVersionUID = -8455197641724609928L;

	public Long getID() {
		return serialVersionUID;
	}
	
	public Double getDefaultValue() {
		return 0.0d;
	}

	public int compare(Object o1, Object o2) {
		return Double.compare((Double)o1, (Double)o2);
	}

	public double getValueDouble(Object value) {
		return (Double)value;
	}

	public boolean higherBetter() {
		return false;
	}

	public boolean hasOrdering() {
		return true;
	}

	public String getName() {
		return "Costs";
	}

	public Set<Constructs> getMeaningfulTypeConstructs() {
		Set<Constructs> constructs = new HashSet<Constructs>();
		constructs.add(Constructs.Originator);
		return constructs;
	}

}
