package org.processmining.plugins.properties.processmodel.impl;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.Set;

import org.processmining.framework.plugin.annotations.KeepInProMCache;
import org.processmining.plugins.properties.annotations.DataPerspective;
import org.processmining.plugins.properties.annotations.PropertableElementProperty;
import org.processmining.plugins.properties.enumerations.Constructs;
import org.processmining.plugins.properties.processmodel.abstractproperty.PropertyListString;

/**
 * 
 * @author DSchunse
 *
 */
@KeepInProMCache
@DataPerspective
@PropertableElementProperty
public class DataValues extends PropertyListString {

	private static final long serialVersionUID = -6489711900627424587L;

	public Long getID() {
		return serialVersionUID;
	}

	public String getName() {
		return "DataValues";
	}

	public int compare(Object o1, Object o2) {
		return 0;
	}

	public ArrayList<String> getDefaultValue() {
		return new ArrayList<String>();
	}

	public double getValueDouble(Object value) {
		return 0;
	}

	public boolean hasOrdering() {
		return false;
	}

	public boolean higherBetter() {
		return false;
	}

	public Set<Constructs> getMeaningfulTypeConstructs() {
		Set<Constructs> constructs = new HashSet<Constructs>();
		constructs.add(Constructs.Variable);
		return constructs;
	}
}
