package org.processmining.plugins.properties.processmodel.impl;

import java.util.HashSet;
import java.util.Set;

import org.processmining.framework.plugin.annotations.KeepInProMCache;
import org.processmining.plugins.properties.annotations.OriginatorPerspective;
import org.processmining.plugins.properties.annotations.PropertableElementProperty;
import org.processmining.plugins.properties.enumerations.Constructs;
import org.processmining.plugins.properties.processmodel.abstractproperty.PropertyString;

@KeepInProMCache
@PropertableElementProperty
@OriginatorPerspective
public class Role extends PropertyString{

	private static final long serialVersionUID = 2524432145975682281L;

	public Long getID() {
		return serialVersionUID;
	}

	public String getName() {
		return "Role allocation";
	}

	public String getDefaultValue() {
		return "NoRole";
	}
	
	public Set<Constructs> getMeaningfulTypeConstructs() {
		Set<Constructs> constructs = new HashSet<Constructs>();
		constructs.add(Constructs.Originator);
		constructs.add(Constructs.ManualTask);
		return constructs;
	}
}
