package org.processmining.plugins.properties.processmodel.impl;

import java.util.HashSet;
import java.util.Set;

import org.processmining.framework.plugin.annotations.KeepInProMCache;
import org.processmining.plugins.properties.annotations.OriginatorPerspective;
import org.processmining.plugins.properties.annotations.PropertableElementProperty;
import org.processmining.plugins.properties.enumerations.Constructs;

/**
 * 
 * @author DSchunse
 *
 */
@KeepInProMCache
@OriginatorPerspective
@PropertableElementProperty
public class TaskDistribution extends Distribution{

	private static final long serialVersionUID = 3852971573640946989L;

	public TaskDistribution(){
		
	}
	
	public TaskDistribution(Distribution distr){
		super(distr);
	}
	
	public Long getID() {
		return serialVersionUID;
	}

	public String getName() {
		return "TaskDistribution";
	}
	
	public TaskDistribution clone(Object element){
		return new TaskDistribution((Distribution) element);
	}
	
	public Set<Constructs> getMeaningfulTypeConstructs() {
		Set<Constructs> constructs =  new HashSet<Constructs>();
		constructs.add(Constructs.ManualTask);
		return constructs;
	}
	
	public Object unmarshall(String xml){
		return new TaskDistribution((Distribution)super.unmarshall(xml));
	}
	
}
