package org.processmining.plugins.properties.processmodel.impl;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.Set;

import javax.swing.ImageIcon;

import org.processmining.framework.plugin.annotations.KeepInProMCache;
import org.processmining.plugins.properties.annotations.OriginatorPerspective;
import org.processmining.plugins.properties.annotations.PropertableElementProperty;
import org.processmining.plugins.properties.enumerations.Constructs;
import org.processmining.plugins.properties.processmodel.TimeValue;
import org.processmining.plugins.properties.processmodel.abstractproperty.PropertyListTimeValue;

/**
 * Specifies a list of available and unavailable
 * @author DSchunse
 *
 */
@KeepInProMCache
@OriginatorPerspective
@PropertableElementProperty
public class WorkSchedule extends PropertyListTimeValue {

	private static final long serialVersionUID = -4885873430234716452L;

	public Long getID() {
		return serialVersionUID;
	}

	public String getName() {
		return "WorkSchedule";
	}

	public ArrayList<TimeValue> getDefaultValue() {
		return new ArrayList<TimeValue>();
	}

	public ImageIcon getIcon() {
		return null;
	}

	public boolean hasOrdering() {
		return false;
	}

	public boolean higherBetter() {
		return false;
	}

	public Set<Constructs> getMeaningfulTypeConstructs() {
		Set<Constructs> constructs = new HashSet<Constructs>();
		constructs.add(Constructs.Originator);
		return constructs;
	}	

}
