package org.processmining.processtree.arrays.impl;

import java.io.File;
import java.io.FileWriter;
import java.io.InputStream;
import java.io.Writer;

import org.processmining.framework.plugin.PluginContext;
import org.processmining.processtree.ProcessTree;
import org.processmining.processtree.arrays.ProcessTreeArray;
import org.processmining.processtree.ptml.exporting.PtmlExportTree;
import org.processmining.processtree.ptml.importing.PtmlImportTree;

import com.csvreader.CsvWriter;

public class ProcessTreeArrayImpl extends org.processmining.basicutils.models.impl.ObjectArrayImpl<ProcessTree> implements ProcessTreeArray {

	public void importFromStream(PluginContext context, InputStream input, String parent) throws Exception {
		this.importFromStream(context, input, parent, new PtmlImportTree());
	}

	public void exportToFile(PluginContext context, File file) throws Exception {
		Writer fileWriter = new FileWriter(file);
		CsvWriter csvWriter = new CsvWriter(fileWriter, ',');
		int n = 1;
		for (ProcessTree pt: list) {
			String fileName = file.getName();
			File dir = file.getParentFile();
			String prefix = fileName.substring(0, fileName.indexOf("."));
			File netFile = File.createTempFile(prefix + "." + n + ".", ".ptml", dir);
			csvWriter.write(netFile.getName());
			csvWriter.endRecord();
			System.out.println("Exporting Process Tree to " + netFile.getName());
			PtmlExportTree exporter = new PtmlExportTree();
			exporter.exportDefault(context, pt, netFile);
			n++;
		}
		csvWriter.close();
	}

}
