package org.processmining.processtree.arrays.plugin;

import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.processtree.ProcessTree;
import org.processmining.processtree.arrays.ProcessTreeArray;
import org.processmining.processtree.arrays.impl.ProcessTreeArrayImpl;
import org.processmining.processtree.impl.ProcessTreeImpl;

public class Plugins {
	
	@Plugin(
		name = "Create Process Tree Array",
		parameterLabels = {},
		returnLabels = { "Process Tree Array" },
		returnTypes = { ProcessTreeArray.class },
		userAccessible = true,
		help = "Create Process Tree Array"
	)
	@UITopiaVariant(
		affiliation = UITopiaVariant.EHV,
		author = "D.M.M. Schunselaar",
		email = "D.M.M.Schunselaar@tue.nl"
	)
	public static ProcessTreeArray createPTArray(PluginContext context, ProcessTree...trees){
		ProcessTreeArray ptArray = new ProcessTreeArrayImpl();
		for(ProcessTree tree: trees){
			ptArray.addElement(new ProcessTreeImpl(tree));
		}
		return ptArray;
	}
}
