package org.processmining.processtree.arrays.visualise;

import javax.swing.JComponent;
import javax.swing.JTabbedPane;

import org.processmining.contexts.uitopia.annotations.Visualizer;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.processtree.arrays.ProcessTreeArray;
import org.processmining.processtree.visualization.bpmn.BPMNVisualization;
import org.processmining.processtree.visualization.tree.TreeVisualization;

public class VisualiseObjectArrays {
	/*
	@Plugin(name = "Visualise Process Tree Array", 
			returnLabels = { "Visualised Process Array" }, 
			returnTypes = { JComponent.class }, 
			parameterLabels = { "Process Tree Array" }, 
			userAccessible = false)
	@Visualizer
	public JComponent visualiseProcessTreeArray(PluginContext context, ProcessTreeArray pta){
		JTabbedPane tabPane = new JTabbedPane(JTabbedPane.TOP, JTabbedPane.WRAP_TAB_LAYOUT);
		TreeVisualization treeVis = new TreeVisualization();
		for(int i = 0; i < pta.getSize(); i++){
			tabPane.addTab(pta.getElement(i).getName() + "-" + i, treeVis.visualizeProperties(context, pta.getElement(i)));
		}
		return tabPane;
	}
	*/
	@Plugin(name = "Visualise Process Tree Array As Trees", 
			returnLabels = { "Visualised Process Array" }, 
			returnTypes = { JComponent.class }, 
			parameterLabels = { "Process Tree Array" }, 
			userAccessible = true)
	@Visualizer
	public JComponent visualiseProcessTreeArrayAsTrees(PluginContext context, ProcessTreeArray pta){
		// make a stacked tab, so we can at least see something in the visualisation
		JTabbedPane mainPane = new JTabbedPane(JTabbedPane.TOP, JTabbedPane.WRAP_TAB_LAYOUT);
		TreeVisualization treeVis = new TreeVisualization();
		for(int i = 0; i < pta.getSize(); i += 100){
			JTabbedPane subTab = new JTabbedPane(JTabbedPane.TOP, JTabbedPane.WRAP_TAB_LAYOUT);
			for(int j = i; j < Math.min(i + 100, pta.getSize()); j++){
				subTab.addTab(pta.getElement(j).getName() + "-" + j, treeVis.visualizeProperties(context, pta.getElement(j).toTree()));
			}
			mainPane.addTab("" + i + "-" + (i + 99), subTab);
		}
		return mainPane;
	}
	
	@Plugin(name = "Visualise Process Tree Array BPMN", 
			returnLabels = { "Visualised Process Array" }, 
			returnTypes = { JComponent.class }, 
			parameterLabels = { "Process Tree Array" }, 
			userAccessible = true)
	@Visualizer
	public JComponent visualiseProcessTreeArrayBPMN(PluginContext context, ProcessTreeArray pta){
		JTabbedPane mainPane = new JTabbedPane(JTabbedPane.TOP, JTabbedPane.WRAP_TAB_LAYOUT);
		BPMNVisualization bpmnVis = new BPMNVisualization();
		for(int i = 0; i < pta.getSize(); i += 100){
			JTabbedPane subTab = new JTabbedPane(JTabbedPane.TOP, JTabbedPane.WRAP_TAB_LAYOUT);
			for(int j = i; j < Math.min(i + 100, pta.getSize()); j++){
				subTab.addTab(pta.getElement(j).getName() + "-" + j, bpmnVis.visualize(context, pta.getElement(j)));
			}
			mainPane.addTab("" + i + "-" + (i + 99), subTab);
		}
		return mainPane;
	}
	
}
