package org.processmining.processtree.configuration.controlflow.impl;

import java.util.Set;
import java.util.UUID;

import org.processmining.processtree.configuration.controlflow.ControlFlowConfiguration;

public class ControlFlowConfigurationExport {

	public static String blocked = "blocked";
	public static String notBlocked = "nonblocked";
	public static String hidden = "hidden";
	public static String notHidden = "nonhidden";
	public static String replacement = "replacement";
	public static String notReplacement = "nonreplacement";
	
	public static String export(boolean headerFooter, ControlFlowConfiguration cfConfiguration){
		String exportString = "";
		if(headerFooter){
			exportString += "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n";
		}
		exportString += "<ControlFlowConfiguration>\n";
		exportString += exportElements(blocked, cfConfiguration.getBlockedEdges());
		exportString += exportElements(notBlocked, cfConfiguration.getNonBlockedEdges());
		
		exportString += exportElements(hidden, cfConfiguration.getHiddenEdges());
		exportString += exportElements(notHidden, cfConfiguration.getNonHiddenEdges());
		
		exportString += exportSelectedElements(cfConfiguration);
		exportString += exportNonSelectedElements(cfConfiguration);
		exportString += "</ControlFlowConfiguration>\n";
		if(headerFooter){
			exportString += "</xml>";
		}
		return exportString;
	}
	
	private static String exportElements(String elementName, Set<UUID> elements){
		String exportString = "<" + elementName + ">\n";
		for(UUID element: elements){
			exportString += "\t<id=\"" + element + "\"/>\n";
		}
		exportString += "</" + elementName + ">\n";
		return exportString;
	}
	
	private static String exportSelectedElements(ControlFlowConfiguration cfConfiguration){
		String exportString = "<" + replacement + ">\n";
		for(UUID key: cfConfiguration.getSelectedReplacements().keySet()){
			UUID value = cfConfiguration.getSelectedReplacements().get(key);
			exportString += "<id=\"" + key + "\" value=\"" + value + "\"/>\n";
		}
		exportString += "</" + replacement + ">\n";
		return exportString;
	}
	
	private static String exportNonSelectedElements(ControlFlowConfiguration cfConfiguration){
		String exportString = "<" + notReplacement + ">\n";
		for(UUID key: cfConfiguration.getNonSelectedReplacements().keySet()){
			for(UUID value: cfConfiguration.getNonSelectedReplacements().keySet()){
				exportString += "<id=\"" + key + "\" value=\"" + value + "\"/>\n";
			}
		}
		exportString += "</" + notReplacement + ">\n";
		return exportString;
	}
}
