package org.processmining.processtree.configuration.impl;

import org.processmining.processtree.ProcessTree;
import org.processmining.processtree.configuration.Configuration;
import org.processmining.processtree.configuration.ConfigurationInstantiater;
import org.processmining.processtree.configuration.controlflow.ControlFlowConfigurationInstantiater;
import org.processmining.processtree.configuration.controlflow.impl.ControlFlowConfigurationInstantiaterImpl;
import org.processmining.processtree.configuration.data.DataConfigurationInstantiater;
import org.processmining.processtree.configuration.data.impl.DataConfigurationInstantiaterImpl;
import org.processmining.processtree.configuration.originator.OriginatorConfigurationInstantiater;
import org.processmining.processtree.configuration.originator.impl.OriginatorConfigurationInstantiaterImpl;
import org.processmining.processtree.impl.ProcessTreeImpl;

/**
 * @author DSchunse
 */

public class ConfigurationInstantiaterImpl implements ConfigurationInstantiater{
	
	public ProcessTree instantiate(ProcessTree treeIn, Configuration conf) {
		return instantiate(treeIn, conf, false);
	}
	
	public ProcessTree instantiate(ProcessTree treeIn, Configuration conf, Boolean makeConfigurationComplete){
		ProcessTree ret = new ProcessTreeImpl(treeIn);
		if(conf.getControlFlowConfiguration() != null){
			ControlFlowConfigurationInstantiater cfInst = new ControlFlowConfigurationInstantiaterImpl();
			ret = cfInst.instantiate(ret, conf.getControlFlowConfiguration(), makeConfigurationComplete);
		}
		if(conf.getDataConfiguration() != null){
			DataConfigurationInstantiater dInst = new DataConfigurationInstantiaterImpl();
			ret = dInst.instantiate(ret, conf.getDataConfiguration(), makeConfigurationComplete);
		}
		if(conf.getOriginatorConfiguration() != null){
			OriginatorConfigurationInstantiater oInst = new OriginatorConfigurationInstantiaterImpl();
			ret = oInst.instantiate(ret, conf.getOriginatorConfiguration(), makeConfigurationComplete);
		}
		return ret;
	}
}
