package org.processmining.processtree.connections;

import org.processmining.framework.connections.impl.AbstractConnection;
import org.processmining.processtree.ProcessTree;
import org.processmining.processtree.arrays.impl.ConfigurationArrayImpl;

/**
 * Connects a {@link ConfigurationArray} object to a single {@link ProcessTree}
 * using a weak connection (e.g. the connection is removed whenever one of these
 * is removed).
 * 
 * @author jbuijs
 * 
 */
public class ConfigurationArrayToProcessTreeConnection extends AbstractConnection {

	public static final String PROCESSTREE = "PROCESSTREE";

	public static final String CONFIGURATIONARRAY = "CONFIGURATIONARRAY";

	public ConfigurationArrayToProcessTreeConnection(ConfigurationArrayImpl configurationArray, ProcessTree processTree) {
		super("Configurationarray to Process Tree");
		put(PROCESSTREE, processTree);
		put(CONFIGURATIONARRAY, configurationArray);
	}
}
