package org.processmining.processtree.connections;

import org.processmining.framework.connections.impl.AbstractConnection;
import org.processmining.processtree.ProcessTree;
import org.processmining.processtree.configuration.Configuration;

/**
 * Connects a {@link Configuration} object to a single {@link ProcessTree} using
 * a weak connection (e.g. the connection is removed whenever one of these is
 * removed, but the other object is not removed).
 * 
 * @author jbuijs
 * 
 */
@SuppressWarnings("deprecation")
public class ConfigurationToProcessTreeConnection extends AbstractConnection {


	public static final String PROCESSTREE = "PROCESSTREE";

	public static final String CONFIGURATION = "CONFIGURATION";

	public ConfigurationToProcessTreeConnection(Configuration configuration, ProcessTree processTree) {
		super("Configuration to Process Tree");
		put(PROCESSTREE, processTree);
		put(CONFIGURATION, configuration);
	}


}
