package org.processmining.processtree.connections;

import org.processmining.framework.connections.impl.AbstractConnection;
import org.processmining.processtree.arrays.ProcessTreeArray;
import org.processmining.processtree.configuration.controlflow.ControlFlowConfigurationArray;

/**
 * Connects a {@link ControlFlowConfigurationArray} object to an {@link ProcessTreeArray}
 * using a weak connection (e.g. the connection is removed whenever one of these
 * is removed).
 * 
 * @author jbuijs && dschunse
 * 
 */
public class ControlFlowConfigurationArrayToProcessTreeArrayConnection extends AbstractConnection {

	public static final String PROCESSTREEARRAY = "PROCESSTREEARRAY";

	public static final String CONTROLFLOWCONFIGURATIONARRAY = "CONTROLFLOWCONFIGURATIONARRAY";

	public ControlFlowConfigurationArrayToProcessTreeArrayConnection(ControlFlowConfigurationArray configurationArray,
			ProcessTreeArray processTreeArray) {
		super("Control Flow Configuration array to Process Tree array");
		put(PROCESSTREEARRAY, processTreeArray);
		put(CONTROLFLOWCONFIGURATIONARRAY, configurationArray);
	}

}
