package org.processmining.processtree.connections;

import org.processmining.framework.connections.impl.AbstractConnection;
import org.processmining.processtree.ProcessTree;
import org.processmining.processtree.configuration.controlflow.ControlFlowConfigurationArray;

/**
 * Connects a {@link ControlFlowConfigurationArray} object to a single {@link ProcessTree}
 * using a weak connection (e.g. the connection is removed whenever one of these
 * is removed).
 * 
 * @author jbuijs && deschune
 * 
 */
public class ControlFlowConfigurationArrayToProcessTreeConnection extends AbstractConnection {

	public static final String PROCESSTREE = "PROCESSTREE";

	public static final String CONTROLFLOWCONFIGURATIONARRAY = "CONTROLFLOWCONFIGURATIONARRAY";

	public ControlFlowConfigurationArrayToProcessTreeConnection(ControlFlowConfigurationArray configurationArray, ProcessTree processTree) {
		super("Control Flow Configuration array to Process Tree");
		put(PROCESSTREE, processTree);
		put(CONTROLFLOWCONFIGURATIONARRAY, configurationArray);
	}
}
