package org.processmining.processtree.conversion.yawl;

import java.io.File;
import java.io.FileWriter;
import java.io.InputStream;

import org.processmining.contexts.uitopia.annotations.UIImportPlugin;
import org.processmining.framework.abstractplugins.AbstractImportPlugin;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.yawlfoundation.yawl.editor.specification.SpecificationArchiveHandler;
import org.yawlfoundation.yawl.editor.specification.SpecificationModel;

@Plugin(name = "Import YAWL Specification from YAWL file", parameterLabels = { "Filename" }, returnLabels = { "YAWL Specification" }, returnTypes = { SpecificationModel.class })
@UIImportPlugin(description = "YAWL files", extensions = { "yawl" })
public class ImportYAWLSpecification extends AbstractImportPlugin {

	@SuppressWarnings("unused")
	protected Object importFromStream(PluginContext context, InputStream input, String filename, long fileSizeInBytes)
			throws Exception {
		File tempFile = new File("tempFile.yawl");
		FileWriter writer = new FileWriter(tempFile);
		int character;
		while((character = input.read()) != -1){
			writer.write(character);
		}
		writer.close();
		SpecificationArchiveHandler.getInstance().processOpenRequest("tempFile");
		SpecificationModel specification = new SpecificationModel();
		SpecificationModel toCopyFrom = SpecificationModel.getInstance();
		tempFile.delete();
		return toCopyFrom;
		
	}

}
