package org.processmining.processtree.conversion.yawl;

import java.util.Map;

import org.processmining.framework.util.Pair;
import org.processmining.processtree.Block;
import org.processmining.processtree.Edge;
import org.processmining.processtree.Node;
import org.processmining.processtree.ProcessTree;
import org.yawlfoundation.yawl.editor.elements.model.EngineIdentifier;
import org.yawlfoundation.yawl.editor.elements.model.VertexContainer;
import org.yawlfoundation.yawl.editor.net.NetGraphModel;

public class YawlExitConverter implements YawlConverter {

	public YawlExitConverter() {
	}

	public Pair<VertexContainer, VertexContainer> convert(ProcessTree tree, Node node, NetGraphModel netGraphModel,
			VertexContainer exitNode, ProcessTree2Yawl pt2y, Map<Edge, Pair<EngineIdentifier, EngineIdentifier>> mappingEdgeIds) {
		/*
		 * exitNode should be the omega-task corresponding to the innermost surrounding loop or the output condition 
		 * corresponding to the innermost surrounding multi-parented node (whichever is innermost).
		 */
		if (((Block)node).getChildren().size() != 1) {
			return null;
		}
		Node childNode = ((Block)node).getChildren().get(0);
		Pair<VertexContainer, VertexContainer> fragment = pt2y.convert(tree, childNode, netGraphModel, exitNode, pt2y, mappingEdgeIds);
		YAWLUtil.createEdge(netGraphModel, fragment.getSecond(), exitNode);
		
		return new Pair<VertexContainer, VertexContainer>(fragment.getFirst(), null);
	}
}



