package org.processmining.processtree.editor.editorpanel;

import java.awt.event.ActionEvent;

import javax.swing.JTextField;

import org.processmining.processtree.ProcessTree;
import org.processmining.processtree.editor.graphpanel.GraphPanel;
import org.processmining.processtree.editor.interaction.GraphMouseListener;
import org.processmining.processtree.impl.AbstractOriginator;

public class EditorActionListenerAddOriginator implements EditorActionListener{
	ProcessTree tree;
	GraphMouseListener graphMouseListener;
	GraphPanel graphPanel;
	JTextField nameField;
	Boolean isResource;
	Boolean isRole;
	Boolean isGroup;
	
	public EditorActionListenerAddOriginator(ProcessTree tree, GraphMouseListener graphMouseListener, GraphPanel graphPanel, JTextField nameField, Boolean isResource, Boolean isRole, Boolean isGroup){
		this.tree = tree;
		this.graphMouseListener = graphMouseListener;
		this.graphPanel = graphPanel;
		this.nameField = nameField;
		this.isResource = isResource;
		this.isRole = isRole;
		this.isGroup = isGroup;
	}
	
	public void actionPerformed(ActionEvent e) {
		String name = nameField.getText();
		if(isResource){
			tree.addOriginator(new AbstractOriginator.Resource(name));
		}
		if(isRole){
			tree.addOriginator(new AbstractOriginator.Role(name));
		}
		if(isGroup){
			tree.addOriginator(new AbstractOriginator.Group(name));
		}
		graphMouseListener.mousePressed(null);
	}
	
	public boolean isEnabled(){
		return true;
	}
}
