package org.processmining.processtree.editor.editorpanel;

import java.awt.event.ActionEvent;

import javax.swing.JTextField;

import org.processmining.processtree.ProcessTree;
import org.processmining.processtree.editor.graphpanel.GraphPanel;
import org.processmining.processtree.editor.interaction.GraphMouseListener;
import org.processmining.processtree.impl.VariableImpl;

public class EditorActionListenerAddVariable implements EditorActionListener{
	ProcessTree tree;
	GraphMouseListener graphMouseListener;
	GraphPanel graphPanel;
	JTextField nameField;
	
	public EditorActionListenerAddVariable(ProcessTree tree, GraphMouseListener graphMouseListener, GraphPanel graphPanel, JTextField nameField){
		this.tree = tree;
		this.graphMouseListener = graphMouseListener;
		this.graphPanel = graphPanel;
		this.nameField = nameField;
	}
	
	public void actionPerformed(ActionEvent e) {
		if(!isEnabled()){
			return;
		}
		String name = nameField.getText();
		tree.addVariable(new VariableImpl(name));
		graphMouseListener.mousePressed(null);
	}
	
	public boolean isEnabled(){
		return true;
	}
}
