package org.processmining.processtree.editor.editorpanel;

import java.awt.event.ActionEvent;
import java.util.UUID;

import org.processmining.processtree.Edge;
import org.processmining.processtree.Node;
import org.processmining.processtree.ProcessTree;
import org.processmining.processtree.editor.graphpanel.GraphPanel;
import org.processmining.processtree.editor.interaction.GraphMouseListener;

public class EditorActionListenerToggleBlockingHiding implements EditorActionListener{
	ProcessTree tree;
	GraphMouseListener graphMouseListener;
	GraphPanel graphPanel;
	Boolean toggleBlocking;
	Boolean toggleHiding;
	
	public EditorActionListenerToggleBlockingHiding(ProcessTree tree, GraphMouseListener graphMouseListener, GraphPanel graphPanel, Boolean toggleBlocking, Boolean toggleHiding){
		this.tree = tree;
		this.graphMouseListener = graphMouseListener;
		this.graphPanel = graphPanel;
		this.toggleBlocking = toggleBlocking;
		this.toggleHiding = toggleHiding;
	}

	public void actionPerformed(ActionEvent e) {
		if(!isEnabled()){
			return;
		}
		UUID toggleID = graphMouseListener.getSelectedID();
		if(tree.getElement(toggleID) instanceof Edge){
			toggle(tree.getEdge(toggleID));
		}
		if(tree.getElement(toggleID) instanceof Node){
			for(Edge edge: tree.getNode(toggleID).getIncomingEdges()){
				toggle(edge);
			}
		}
		graphPanel.redraw();
	}
	
	public boolean isEnabled(){
		UUID toggleID = graphMouseListener.getSelectedID();
		if(toggleID == null){
			return false;
		}
		return (tree.getElement(toggleID) instanceof Edge || (tree.getElement(toggleID) instanceof Node && ((Node)tree.getElement(toggleID)).getIncomingEdges().size() > 0));
	}
	
	private void toggle(Edge edge){
		if(toggleBlocking){
			edge.setBlockable(!edge.isBlockable());
		}
		if(toggleHiding){
			edge.setHideable(!edge.isHideable());
		}
	}
}
