package org.processmining.processtree.ptml;

import java.util.Map;
import java.util.UUID;

import org.processmining.processtree.Originator;
import org.processmining.processtree.ProcessTree;

public abstract class PtmlOriginator extends PtmlProcessTreeElement {
	
	public PtmlOriginator(String tag, UUID id) {
		super(tag, id);
	}
	
	public abstract void unmarshall(ProcessTree tree, Map<UUID, Originator> originatorMap);
	
	public void unmarshall(ProcessTree tree, Map<UUID, Originator> originatorMap, Originator originator) {
		if (name != null) {
			originatorMap.put(id, originator);
			tree.addOriginator(originator);
			if(propertyIndependent != null){
				propertyIndependent.unmarshall(originator);
			}
			if(propertyDependent != null){
				propertyDependent.unmarshall(originator);
			}
		}
	}

	public void marshall(ProcessTree tree, Originator originator, Map<Originator, UUID> originatorMap) {
		id = originator.getID();
		name = originator.getName();
		originatorMap.put(originator, id);
		if(!originator.getIndependentProperties().isEmpty()){
			propertyIndependent = new PtmlPropertyIndependent();
			propertyIndependent.marshall(originator.getIndependentProperties());
		}
		if(!originator.getDependentProperties().isEmpty()){
			propertyDependent = new PtmlPropertyDependent();
			propertyDependent.marshall(originator.getDependentProperties());
		}
	}

}
