package org.processmining.processtree.ptml;

import java.util.Map;
import java.util.UUID;

import org.processmining.processtree.Originator;
import org.processmining.processtree.ProcessTree;
import org.processmining.processtree.impl.AbstractOriginator;

public class PtmlResource extends PtmlOriginator {
	
	public final static String TAG = "resource";
	
	public PtmlResource(UUID id) {
		super(TAG, id);
	}

	public void unmarshall(ProcessTree tree, Map<UUID, Originator> originatorMap) {
		Originator originator = new AbstractOriginator.Resource(id, name);
		unmarshall(tree, originatorMap, originator);
	}
	
	public boolean equals(Object o) {
		return ((o instanceof PtmlResource) && (id.equals(((PtmlResource) o).id)));
	}
	
	public int hashCode() {
		return id.hashCode();
	}
}
